<?php

class BulkUploader_Controller extends Controller
{
	static $allowed_actions = array (
		'upload',
		'handleswfupload',
		'UploadForm',
		'ReturnForm',
		'edit',
		'editpopup',
		'EditForm',
		'close',
		'delete',
		'ImportForm',
		'defaultform'
	);
	
	
	function init()
	{
		parent::init();
		Requirements::css('bulk_uploader/css/BulkUploader.css');
		Requirements::javascript('jsparty/prototype.js');
		Requirements::javascript('jsparty/prototype-improvements.js');
		Requirements::javascript('jsparty/behaviour.js');
		Requirements::block('sortable_dataobject/javascript/jquery-1.2.6.min.js');
		
		foreach($this->urlParams as $key => $value)
			$this->$key = $value;
	}
	
	function Link($action = null) {
		return $this->RelativeLink($action);
	}
	
	function RelativeLink($action = null, $id = null) {
		if(!$action) $action = "index";
		if(!$id) $id = $this->ControllerID;
		
		return "bulkuploader/$action/{$this->ControllerFieldName}/{$this->ControllerClassName}/{$this->DataObjectFieldName}/{$this->DataObjectClassName}/{$this->FileFieldName}/{$this->FileClassName}/{$id}";
	}
	
	public function HasImages()
	{
		if($files = $this->FileObjects()) {
			foreach($files as $file) {
				if($file->obj($this->FileFieldName) instanceof Image) {
					return true;
				}
			}
			return false;
		}
		else return false;
	}
	
	private function FileObjects()
	{
		$page = DataObject::get_by_id($this->ControllerClassName,$this->ControllerID);
		$do_method = $this->DataObjectFieldName;	
		$fileObjects = $page->$do_method();
		if($fileObjects) {
			$fileObjects->sort('ID','ASC');
			return $fileObjects;
		}
		else return false;
	}

	public function FileList()
	{
		Requirements::javascript('bulk_uploader/javascript/tooltip.js');
Requirements::customScript("  jQuery('a.tooltip').tooltip({
		delay: 0,
		showURL: false,
		track: true,
		bodyHandler: function() {
			return jQuery(this).find('span.file-info').html();
		}
	});
");		
		if($fileObjects = $this->FileObjects()) {
			$file_method = $this->FileFieldName;
			foreach($fileObjects as $o) {
				$o->File = $o->$file_method();
				$o->EditLink = $this->RelativeLink('edit',$o->ID);
				$o->DeleteLink = $this->RelativeLink('delete',$o->ID);
				$o->isImage = $o->obj($this->FileFieldName) instanceof Image;
				$o->ExtraFields = new DataObjectSet();
				foreach(singleton($this->DataObjectClassName)->stat('bulk_uploader_fields') as $name => $value)
					$o->ExtraFields->push(new ArrayData(array('Name' => $name, 'Value' => $o->obj($name))));
			}
			return $fileObjects;
		}
		else return false;
	}
	
	public function Sortable()
	{
		if(class_exists("SortableDataObject"))
			return SortableDataObject::is_sortable_class($this->DataObjectClassName);
		else return false;
	}
	
	public function index()
	{
		Requirements::javascript('bulk_uploader/javascript/jquery-1.2.5.min.js');
		Requirements::javascript('bulk_uploader/javascript/tooltip.js');
		Requirements::javascript('bulk_uploader/javascript/bulk_uploader.js');
		return $this->renderWith(array ('BulkUploader'));
	}
	public function upload()
	{
		return $this->renderWith(array ('BulkUploader_upload'));
	}
	
	public function FileTypes()
	{
		if($types = singleton($this->DataObjectClassName)->stat('allowed_file_types'))
			return implode(", ", $types);
		else return false;
	}
	
	public function UploadForm()
	{
		
		if($types = singleton($this->DataObjectClassName)->stat('allowed_file_types')) {
			foreach($types as $type)
				SWFUploadConfig::addFileType($type);
		}

		$fields = new FieldSet(
			new SWFUploadField("UploadForm","","",array(
				'file_upload_limit' => '100', // how many files can be uploaded
				'file_queue_limit' => '100', // how many files can be in the queue at once
				'browse_button_text' => 'Choose files...',
				'upload_url' => '/'.$this->RelativeLink('handleswfupload')
			))
		);
		return new Form(
			$this,
			"UploadForm",
			$fields,
			new FieldSet(
				new FormAction('doUpload','Upload File(s)')
			)			
		);
	}
	
	public function doUpload($data, $form)
	{
		if(isset($_POST['uploaded_files']) && !empty($_POST['uploaded_files'])) {
			return $this->renderWith('BulkUploader_return');
		}
		else Director::redirectBack();
	}
	
	public function handleswfupload()
	{
		if(isset($_FILES['swfupload_file']) && !empty($_FILES['swfupload_file'])) {
			$obj = new $this->DataObjectClassName;
			if($this->Sortable()) {
				if($files = $this->FileObjects())
					$obj->SortOrder = $files->Count() + 1;
			}
			$idxfield = $this->FileFieldName."ID";

			$file = new $this->FileClassName;
			
			if(class_exists("Upload")) {
				$u = new Upload();
				$u->loadIntoFile($_FILES['swfupload_file'], $file);
			}
			else
				$file->loadUploaded($_FILES['swfupload_file']);

			$file->write();
			$obj->$idxfield = $file->ID;
			$ownerID = $this->ControllerFieldName."ID";
			$obj->$ownerID = $this->ControllerID;

			$obj->write();
			echo $obj->ID;
		}
		else {
			echo ' ';
		}
	}
	
	public function ReturnForm()
	{
		if(isset($_POST['uploaded_files']) && is_array($_POST['uploaded_files'])) {
			$list = implode("','",$_POST['uploaded_files']);
			$uploaded_files = DataObject::get($this->DataObjectClassName,"ID IN ('" . $list . "')");
		}
		else {
			$uploaded_files = new DataObjectSet();
		}
		$extraFields = singleton($this->DataObjectClassName)->stat('bulk_uploader_fields');
		
		$fieldSet = new FieldSet();
		foreach($uploaded_files as $f) {
			$image = $f->obj($this->FileFieldName) instanceof Image ? "image" : "";
			$holder = new FieldSet();
			$holder->push(new HeaderField($title = $f->obj($this->FileFieldName)->Title, $headingLevel = "4"));
			if($image)
				$holder->push(new LiteralField("image_{$f->ID}", "<div class='file-thumbnail $image'><img src='".$f->obj($this->FileFieldName)->CroppedImage(100,100)->URL."' alt='".$f->Filename."'/></div>"));
			else
				$holder->push(new LiteralField("image_{$f->ID}", "<div class='file-thumbnail'><img src='".$f->obj($this->FileFieldName)->Icon()."' alt='' /></div>"));
			$holder->push(new LiteralField("fields_{$f->ID}", "<div class='extrafields $image'>"));
			if($extraFields !== null) {
				foreach($extraFields as $name => $fieldType) {
					$fieldObj = new $fieldType($name);
					$fieldObj->setName("extrafields[{$f->ID}][".$fieldObj->Name()."]");
					$holder->push($fieldObj);
				}
			}
			$holder->push(new LiteralField("fields_{$f->ID}_close", "</div>"));
			$fieldSet->push(new CompositeField($holder));
		}
		return new Form(
			$this,
			"ReturnForm",
			$fieldSet,
			new FieldSet(
				new FormAction('saveFiles','Save')
			)
		);
	}
	
	public function saveFiles($data,$form)
	{
		if(isset($_POST['extrafields']) && is_array($_POST['extrafields'])) {
			foreach($_POST['extrafields'] as $id => $fields) {
				$obj = DataObject::get_by_id($this->DataObjectClassName,$id);
				foreach($fields as $name => $value) {
					$obj->$name = $value;
				}
				$obj->write();
			}
			Director::redirect($this->RelativeLink());
		}
	}
	
	public function EditFormHolder()
	{

		return "<iframe id='EditFormHolder' src='".$this->RelativeLink('defaultform')."' style='height: 600px; width: 100%;overflow:auto;border: none;' frameborder='0'></iframe>";
	}
	
	public function Success()
	{
		if(!isset($_REQUEST['success']) || !is_numeric($_REQUEST['success']))
			return false;
		
		return DataObject::get_by_id($this->DataObjectClassName, $_REQUEST['success'])->obj($this->FileFieldName);
	}
	
	public function CurrentFile()
	{
		return DataObject::get_by_id($this->DataObjectClassName, $this->ControllerID)->obj($this->FileFieldName);
	}
	
	public function EditForm()
	{
		Requirements::customScript("
		parent.jQuery('li.current').removeClass('current');
		parent.jQuery('a[href$={$this->ControllerID}]').parents('li').addClass('current');
");
		$fields = singleton($this->DataObjectClassName)->stat('bulk_uploader_fields');
		$fieldset = new FieldSet();
		foreach($fields as $name => $type)
			$fieldset->push(new $type($name));
		$form = new Form(
			$this,
			"EditForm",
			$fieldset,
			new FieldSet(new FormAction('saveEditForm','Save'))
		);
		$form->loadDataFrom(DataObject::get_by_id($this->DataObjectClassName,$this->ControllerID));
		return $form;
	}
	
	public function saveEditForm($data,$form)
	{
		$foo = DataObject::get_by_id($this->DataObjectClassName,$this->ControllerID);
		$form->saveInto($foo);
		$foo->write();
		Director::redirect($this->RelativeLink('edit',$this->ControllerID)."?success={$this->ControllerID}");
	}
	
	public function delete()
	{
		if(is_numeric($this->ControllerID)) {
			if($obj = DataObject::get_by_id($this->DataObjectClassName,$this->ControllerID))
				$obj->delete();
		}
	}
	
	public function ImportForm()
	{
		return new Form(
			$this,
			"ImportForm",
			new FieldSet(
				new DropdownField("Folder","",DataObject::get("Folder",null,"ParentID ASC")->toDropdownMap(),null,null,'-- Import from folder --')
			),
			new FieldSet(new FormAction('doImport','Import'))
		);
	}
	
	public function doImport($data,$form)
	{
		if($folder = DataObject::get_by_id("Folder",$data['Folder'])) {
			$files = DataObject::get("File","ParentID = $folder->ID");

			$data_object = $this->DataObjectClassName;
			$file_id = $this->FileFieldName."ID";
			$owner_field = $this->ControllerFieldName."ID";
			
			foreach($files as $file) {
				// make sure we haven't already imported the file.
				if(!DataObject::get_one($this->DataObjectClassName, "$file_id = {$file->ID}")) {
					$obj = new $data_object();
					if($this->Sortable()) {
						if($files = $this->FileObjects())
							$obj->SortOrder = $files->Count() + 1;
					}	
					$obj->$file_id = $file->ID;
					$obj->$owner_field = $this->ControllerID;
					$obj->write();
				}
			}
			Director::redirect($this->RelativeLink());
		}
		else {
			Director::redirectBack();
		}
	}
	
	private function PageLink($dir)
	{
		$current = DataObject::get_by_id($this->DataObjectClassName,$this->ControllerID);
		$t = $dir == 'next' ? ">" : "<";
		$filter = $this->Sortable() ? "SortOrder $t $current->SortOrder" : "ID $t '$current->ID'";
		$t = $dir == 'next' ? "ASC" : "DESC";
		$sort = $this->Sortable() ? "SortOrder $t" : "ID $t";
		if($do = DataObject::get_one($this->DataObjectClassName,$filter, false, $sort))
			return $this->RelativeLink('edit',$do->ID);
		else return false;	
	}
	
	public function NextFile()
	{
		return $this->PageLink('next');
	}
	
	public function PrevFile()
	{
		return $this->PageLink('prev');
	}
	

}
?>