<?php

class SWFUploadConfig
{
	static $form_name;
	static $upload_url;
	static $file_destination_path;
	static $file_post_name;
	static $post_params;
	static $file_size_limit;
	static $file_types_list;
	static $file_types_description;
	static $browse_button_text;
	static $file_upload_limit;
	static $file_queue_limit;

	static $required;

	// Event handler settings
	static $swfupload_loaded_handler;
				
	static $file_dialog_start_handler;
	static $file_queued_handler;
	static $file_queue_error_handler;
	static $file_dialog_complete_handler;
				
	static $upload_start_handler;
	static $upload_progress_handler;
	static $upload_error_handler;
	static $upload_success_handler;
	static $upload_complete_handler;

	// Flash Settings
	static $flash_url;

	// UI settings
	static $swfupload_element_id;
	static $degraded_element_id;
			
	static $progress_target;
	static $upload_successful;
	
	// Button settings
	static $button_image_url;
	static $button_width;
	static $button_height;
	static $button_text_style;
	static $button_text_top_padding;
	static $button_text_left_padding;
	
	// Debug settings
	static $debug;
	
	static function addFileType($type)
	{
		if(self::$file_types_list == '*.*')
			self::$file_types_list = '';

		self::$file_types_list .= '*.' . str_replace('.','',$type) .';';
	}
	
	static function addFileTypes($types)
	{	
		if(is_array($types)) {
			foreach($types as $type)
				self::addFileType($type);
		}
	}
	static function addPostParam($param, $value)
	{
		if(!empty(self::$post_params))
			self::$post_params .= ",";

		self::$post_params .= "'" . $param . "' : '" . $value . "'";
	}
	
	static function addPostParams($params)
	{
		if(is_array($params)) {
			foreach($params as $param => $value)
				self::addPostParam($param,$value);
		}
	}
	static function get_var($var)
	{
		return self::$$var;
	}
	
	static function set_var($var, $value)
	{
		if(property_exists('SWFUploadConfig', $var))
			self::$$var = $value;
	}
	
	static function Configure($properties)
	{
		if(is_array($properties))
		{
			foreach($properties as $k => $v)
			{
				if(property_exists('SWFUploadConfig', $k))
				{
					self::$$k = $v;
				}
			}
		}
	}
	
	static function DumpConfiguration()
	{
		return get_class_vars(__CLASS__);
	}
	
	static function Bootstrap()
	{
		Requirements::css('swfupload/css/swfupload.css');

		Requirements::javascript('swfupload/javascript/swfupload.js');
		Requirements::javascript('swfupload/javascript/swfupload.graceful_degradation.js');
		Requirements::javascript('swfupload/javascript/fileprogress.js');
		Requirements::javascriptTemplate('swfupload/javascript/swfupload_vars.js', array(
			'form_name' => self::get_var('form_name'),
			'required' => self::get_var('required')
		));
		Requirements::javascript('swfupload/javascript/handlers.js');
		Requirements::javascriptTemplate('swfupload/javascript/swfu.js', self::DumpConfiguration());	
	}
	
	
}



?>